/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package manegemoniteur;

/**
 *
 * @author Doum
 */
public class ManegeMoniteur {
    private static final int NB_PLACES = 5;
    public int placesDisponibles = 0;
    public int personnesSorties = 0;
    public boolean manegeEnFonction = true;
    
    public synchronized void prendrePlace(int idPassager)
    {
        try {
            while (placesDisponibles == 0)
                this.wait();
            System.out.println("Passager " + idPassager + " entre dans manege.");     
            placesDisponibles--;
            if (placesDisponibles == 0)
                this.notifyAll();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public synchronized void sortir(int idPassager)
    {
        try {
            while (manegeEnFonction)
                this.wait();
            personnesSorties++;
            if (personnesSorties == NB_PLACES)
                this.notifyAll();
            System.out.println("Passager " + idPassager + " sort du manege.");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public synchronized void toursDeManege()
    {
        try {
            manegeEnFonction = true;
            placesDisponibles = NB_PLACES;
            personnesSorties = 0;
            this.notifyAll();
            while (placesDisponibles != 0)
                this.wait();
            System.out.println("Manege demarre.");
            wait(2000);
            System.out.println("Manege arrete.");
            manegeEnFonction = false; 
            System.out.println("Les passagers sortent du manège.");           
            this.notifyAll(); 
            while (personnesSorties != NB_PLACES)
                this.wait();
            
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
            
   
}
