/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package philosophessemaphore;

import java.util.Random;
import java.util.concurrent.Semaphore;

/**
 *
 * @author Doum
 */
public class Philosophe extends Thread {
    private static Semaphore baguettes[] = new Semaphore[5];
    private static Random random = new Random(System.currentTimeMillis());
    private int id;
    
    
    
    public static void main(String[] args) {
        for (int i=0;i<5;i++)
        {
            baguettes[i] = new Semaphore(1);
            Philosophe philosophe = new Philosophe(i);
            philosophe.start();
        }     
    }
    
    public Philosophe(int id)
    {
        this.id = id;
    }
    
    @Override
    public void run()
    {
        int indexBaguette1 = 0;
        int indexBaguette2 = 0;
        while (true)
        {           
            try {
                System.out.println("philosophe " + id + " pense");
                Thread.sleep(random.nextInt(2000) + 1000);

                System.out.println("philosophe " + id + " a faim");

                indexBaguette1 = id;
                indexBaguette2 = (id + 1) % 5;
                if (id % 2 == 0) {
                    indexBaguette1 = (id + 1) % 5;
                    indexBaguette2 = id;
                }

                baguettes[indexBaguette1].acquire();
                System.out.println("baguette " + indexBaguette1 + " prise par le philosophe " + id);
                baguettes[indexBaguette2].acquire();
                System.out.println("baguette " + indexBaguette2 + " prise par le philosophe " + id);

                System.out.println("philosophe " + id + " commence a manger");
                Thread.sleep(random.nextInt(5000) + 1000);
                System.out.println("philosophe " + id + " a fini de manger");

                System.out.println("baguette " + indexBaguette1 + " remise par le philosophe " + id);
                baguettes[indexBaguette1].release();
                System.out.println("baguette " + indexBaguette2 + " remise par le philosophe " + id);
                baguettes[indexBaguette2].release();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        }    
    }
}
    
